	P386N                   ;allow 386 instr. (movsd)
	IDEAL
	MODEL small

	DATASEG

	D EQU 64 ;if you change D here, remember to also change it in mklens.c

	EXTRN   _tfm:word       ;tfm is declared and calculated in mklens.c
	buffer  DB      (D*D) dup (?) ;used to save the background

	CODESEG

	PUBLIC  _lenshow        ;lenshow(x,y);
	PUBLIC  _restore        ;restore(x,y);
	PUBLIC  _screenadr      ;scr = screenadr();
	PUBLIC  _wtsync         ;wtsync();
	PUBLIC  _setmode        ;setmode(0x013);

;copies block of D*D pix at x,y to buffer
;then transforms it via tfm and draws it back to the screen
PROC    _lenshow       NEAR
	ARG x:Word, y:Word
	push    bp
	mov     bp,sp
	push    si
	push    di
	push    ds

;--------------------- copy from screen to buffer ---------------------

	push    ds
	pop     es              ;es = ds
	mov     ax,0a000h
	mov     ds,ax           ;ds=screen memory
	mov     bx,[y]
	mov     si,[x]
	shl     bx,8
	add     si,bx           ;si = x + 256*y
	shr     bx,2
	add     si,bx           ;si = x + 320*y
	mov     di,offset buffer ;es:di = buffer
	mov     dx,D            ;dx=height of lens
@@loop1:
	mov     cx,(D/4)        ;width in dwords
	rep     movsd           ;copy one row
	add     si,(320-D)      ;jump to next row on screen
	dec     dx              ;decrease loopcounter
	jnz     @@loop1         ;loop through all rows
	pop     ds              ;restore ds

;--------------        copy from buffer via tfm to screen       ------------
;------------------         scr[x,y]=buffer[tfm[x,y]]        ---------------

	sub     si,(320*D)      ;si=beginning of block on the screen
	mov     di,si           ;let es:di point to screen
	mov     ax,0a000h
	mov     es,ax
	lea     si,[_tfm]        ;ds:si point to tfm
	mov     dx,D            ;height to dx
@@loop2:
	mov     cx,D            ;width to cx
@@loop3:
	mov     bx,[ds:si]      ;index from tfm to bx
	inc     si
	inc     si
	mov     al,[bx + buffer] ;move the color to al
	mov     [es:di],al      ;draw one pixel
	inc     di
	loop    @@loop3         ;loop through one row
	add     di,(320-D)      ;jump to next row
	dec     dx
	jnz     @@loop2         ;loop through all rows
	pop     di
	pop     si
	pop     bp
	ret
ENDP    _lenshow


;-------------------------------------------------------------------
;-------- restore puts the buffer back on the screen at x,y --------
;-------------------------------------------------------------------
PROC    _restore        NEAR
	ARG x:Word, y:Word
	push    bp
	mov     bp,sp
	push    si
	push    di

;---------------------Copy from buffer to screen ---------------------

	mov     ax,0a000h
	mov     es,ax           ;es=screen memory
	mov     bx,[y]
	mov     di,[x]
	shl     bx,8
	add     di,bx           ;di = x + 256*y
	shr     bx,2
	add     di,bx           ;di = x + 320*y
	lea     si,[buffer]     ;ds:si = buffer
	mov     dx,D            ;dx=height of lens
@@lp:   mov     cx,(D/4)        ;width in dwords
	rep     movsd           ;copy one row
	add     di,(320-D)      ;jump to next row on screen
	dec     dx              ;decrease loopcounter
	jnz     @@lp            ;loop through all rows
	pop     di
	pop     si
	pop     bp
	ret
ENDP    _restore        

;-------------------- Returns a000:0000 --------------------

PROC    _screenadr      NEAR
	xor     ax,ax
	mov     dx,0a000h
	ret
ENDP    _screenadr

;--------- hope you're familliar with this one by now -----------------
PROC    _wtsync NEAR
	push    ax
	push    dx
	mov     dx,3DAh
@@wt1:  in      al,dx
	test    al,8
	jne     @@wt1
@@wt2:  in      al,dx
	test    al,8
	je      @@wt2
	pop     dx
	pop     ax
	ret
ENDP    _wtsync
	
;---------------- and this one too ... -------------------------
PROC    _setmode  NEAR
	ARG     mode:Word
	push    bp
	mov     bp,sp
	mov     ax,[mode]
	int     10h
	pop     bp
	ret
ENDP    _setmode

	END                     ;end of module
